;;;-------------------------------------------------------------------------
;;; File BS        BS (Block Search) Command                        11/27/81
;;;-------------------------------------------------------------------------
;;;
;;;  BLOCK SEARCH   BS <ADDR1> <ADDR2> 'LITERAL STRING'
;;;                 BS <ADDR1> <ADDR2> <DATA> [<MASK>] [;<OPTION>]

BSCMD    LEA     SYNTAX(PC),A0
         BSR     FNEXTF
         BSR     GETA
         MOVE.L  D0,A3          	; A3 = FROM BEGIN ADDRESS

         BSR     FNEXTF
         BSR     GETA
         MOVE.L  D0,A1          	; A1 = FROM END ADDRESS

         BSR     FNEXTF
         MOVE.B  (A5),D0
         CMPI.B  #$27,D0
         BEQ     BS311          	; LITERAL STRING SEARCH

         BSR     GETNUMA
         MOVE.L  D0,D7          	; D7 = DATA WE ARE LOOKING FOR
         CLR.L   D5             	; SCAN FOR OPTIONS
         MOVE.L  A5,A0
BS91     CMP.L   A6,A0
         BCC.S   BS97           	; AT END OF BUFFER

         MOVE.B  (A0)+,D0
         CMPI.B  #';',D0
         BNE     BS91           	; NOT SEMICOLON

         MOVE.L  A0,A6
         SUBQ.L  #1,A6          	; ADJUST END OF BUFFER POINTER

         MOVE.B  (A0),D0        	; D0 = OPTION CHARACTER
         CMPI.B  #'B',D0
         BEQ.S   BS97           	; BYTE  D5 = 0

         MOVEQ   #1,D5
         CMPI.B  #'W',D0
         BEQ.S   BS97                	; WORD  D5 = +

         MOVEQ   #-1,D5         	; LONG WORD  D5 = -
         CMPI.B  #'L',D0
         BNE     SYNTAX
BS97     DS      0

         MOVEQ   #-1,D4         	; D4 = DEFAULT SEARCH MASK
         LEA     BS101(PC),A0
         BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETNUMA
         MOVE.L  D0,D4          	; D4 = MASK
BS101    DS      0

         MOVE.L  A3,A0
         BSR     P2PHY          	; PRINT ADDRESSES (A0) & (A1)

         CMP.L   A3,A1
         BCS     SYNTAX         	; END LESS THAN BEGIN

BS200    CMP.L   A1,A3
         BCC     MACSBUG        	; DONE

         BSR     FIXBUF
         MOVE.L  A3,D0
         BSR     PNT6HX         	; FORMAT ADDRESS
         MOVE.B  #BLANK,(A6)+   	; SPACE INTO BUFFER

         TST.L   D5
         BEQ.S   BS225          	; BYTE SIZE

         MOVE.L  A3,D0
         BSR     CKWADR         	; INSURE WORD BOUNDRY
         TST.L   D5
         BPL.S   BS219          	; WORD SIZE (2 BYTES)

         MOVEQ   #2,D6          	; D6 =  SIZE (LONG WORD)
         MOVE.L  (A3),D0        	; FETCH
         AND.L   D4,D0          	; MASK
         CMP.L   D7,D0          	; COMPARE
         BNE.S   BS215

         MOVE.L  (A3),D0        	; DISPLAY NON-MASKED DATA
         BSR     PNT8HX

BS213    BSR     OUT1CR

BS215    ADD.L   D6,A3          	; BUMP FETCH ADDRESS  (D6 = SIZE)
         BRA     BS200

BS219    MOVEQ   #2,D6          	; SIZE = WORD
         MOVE.W  (A3),D0
         AND.W   D4,D0
         CMP.W   D7,D0
         BNE     BS215

         MOVE.W  (A3),D0
         BSR     PNT4HX         	; DISPLAY
         BRA     BS213

BS225    MOVEQ   #1,D6          	; SIZE = BYTE
         MOVE.B  (A3),D0
         AND.B   D4,D0
         CMP.B   D7,D0
         BNE     BS215

         MOVE.B  (A3),D0
         BSR     PNT2HX         	; DISPLAY
         BRA     BS213

;;; LITERAL STRING SEARCH
;;;   SAVE STRING

BS311    LEA     DUMPTEMP,A2
BS313    ADDQ.L  #1,A5
         CMP.L   A6,A5
         BCC     SYNTAX         	; ADDR1 GREATER THAN ADDR2
         MOVE.B  (A5),(A2)+
         MOVE.B  (A5),D0
         CMPI.B  #$27,D0
         BNE     BS313
         SUBQ.L  #1,A2          	; A2 = END OF STRING + 1

         MOVE.L  A3,A0
         BSR     P2PHY          	; DISPLAY ADDRESSES

         CMP.L   A3,A1
         BCS     SYNTAX

;;; LOOK FOR STRING MATCH

BS323    LEA     DUMPTEMP,A4    	; A4 = BEGIN OF STRING
         MOVE.L  A3,A0          	; A0 = BEGIN OF MEMORY
BS325    MOVE.B  (A0),D0
         CMP.B   (A4)+,D0       	; DATA COMPARE
         BNE.S   BS365          	; MIS-MATCH

         CMP.L   A0,A1          	; ADDRESS CHECK
         BCS     MACSBUG        	; OUT OF MEMORY

         ADDQ.L  #1,A0
         CMP.L   A2,A4
         BCS     BS325          	; MORE STRING TO CHECK

         BSR     FIXBUF         	; HAVE MATCH
         MOVE.L  A3,D0          	; FORMAT ADDRESS
         BSR     PNT6HX
         MOVE.B  #BLANK,(A6)+   	; SPACE

         MOVE.B  #$27,(A6)+     	; LEADING QUOTE
         LEA     DUMPTEMP,A4    	; MOVE STRING TO BUFFER
BS355    MOVE.B  (A4)+,(A6)+
         CMP.L   A4,A2
         BCC     BS355

         BSR     OUT1CR         	; DISPLAY

BS365    ADDQ.L  #1,A3
         CMP.L   A3,A1
         BCS     MACSBUG        	; DONE
         BRA     BS323


