;;;-------------------------------------------------------------------------
;;; File H         Register save,Trace, Breakpoint                  03/03/82

;;;       SAVE ALL REGISTERS ROUTINE-JMP [TEMP] BACK
;;;          USUALLY CALLED BY THE MACRO "SAVEREGS"

SAVE     DS      0
         LEA     REGA7,A7       	; WHERE TO START STORING
         MOVEM.L D0-D7/A0-A6,-(A7)  	; SAVE REGISTERS

         LEA     SYSTACK+4,A7   	; SET UP STRETCHED VERSAUG STACK

         MOVE.L  REGA7,A0       	; A0 = TARGETS SUPERVISOR STACK POINTER
         MOVE.W  (A0)+,REGSR+2  	; GET TARGETS SR

         MOVE.L  (A0)+,REGPC    	; GET TARGETS PC

         MOVE.L  A0,REGA7       	; WHERE TARGET STACK REALLY POINTS

         MOVE.L  USP,A1         	; GET USERS STACK POINTER
         MOVE.L  A1,REGUS       	; SAVE IT FOR DISPLAY ETC

         MOVE.L  REGPC,D0       	; GET PROGRAM COUNTER
         SUBQ.L  #4,A7          	; SET REAL MACSBUG STACK
         MOVE.L  TEMP,-(A7)     	; PUT RETURN ADDRESS ON STACK
         RTS                    	; RETURN TO SENDER

;;;
;;;     ***TRACE***  TRACE ENTRY POINT
;;;       ENTER FROM VECTOR 9  (LOCATION 24) FOR
;;;

;;; REGISTER USAGE
;;;  A0 = ADDRESS OF BREAKPOINT ADDRESS
;;;  A2 = ADDRESS OF BREAKPOINT COUNTS
;;;  D1 = PC
;;;  D5 = TRACECNT
;;;  D7 = BKPT COUNT

TRACE    MOVE.W  #$2700,SR      	; MASK OFF INTERRUPTS
         SAVEREGS

;;; IF PC POINTS TO 'TRACE'; DOUBLE EVENT OCCURED
;;;  CLEAR LAST EVENT BY IGNORING

         CMPI.L  #V2,REGPC

         BNE.S   TRACE16

         MOVE.L  REGA7,A5       	; TRIM LAST EVENT FROM STACK
         MOVE.W  (A5)+,REGSR+2  	; *MOVE VALUES FROM STACK TO
         MOVE.L  (A5)+,REGPC    	; *PSUEDO SR, PC,
         MOVE.L  A5,REGA7       	; *REFLECT ADJUSTMENTS IN PSUEDO STACK
TRACE16  ANDI.W  #$7FFF,REGSR+2 	; RESET "T" (TRACE) BIT


         MOVE.L  TRACECNT,D5
         BMI.S   TRACE39        	; EXECUTING ONE-INSTRUCTION
         BEQ     ABORT335       	; NOT TRACEING

;;;   MAKE SURE WE ARE NOT TRACING OURSELVES
         MOVE.L  REGPC,D1       	; GET PC
         LEA.L   FIRST(PC),A0
         CMP.L   A0,D1
         BMI.S   TISOK          	; TRACING BELOW OURSELVES
         LEA     LAST(PC),A0
         CMP.L   A0,D1
         BHI.S   TISOK          	; TRACING ABOVE OURSELVES
         LEA     MSG020(PC),A5  	; TRACING OURSELVES
         BRA     CHKBP4
TISOK

         LEA     BPADD,A0
         LEA     BPCNT,A2
         MOVEQ   #9,D7          	; 9TH BP IS "UNTILL" FEATURE

TRACE01  CMP.L   (A0),D1        	; SEE IF PC MATCHES ADDRESS IN TABLE
         BNE.S   TRACE08
         MOVE.L  (A2),D0        	; GET COUNT
         BEQ     CHKBP3         	; COUNT ZERO
         SUBQ.L  #1,D0          	; COUNT DOWN
         MOVE.L  D0,(A2)        	; SAVE IT
         BEQ     CHKBP3         	; COUNT WENT TO ZERO
         BRA.S   TRACE03

TRACE08  ADDQ.L  #4,A0          	; BUMP TABLE POINTER
         ADDQ.L  #4,A2          	; BUMP COUNT TABLE POINTER
         SUBQ.L  #1,D7          	; LOOP AROUND
         BNE     TRACE01

TRACE03  BSR     TDISPLY        	; DO TRACE DISPLAY
         SUBQ.L  #1,TRACECNT    	; TRACE COUNT
         BEQ     MACSBUG        	; STOP WHEN ZERO
         BRA.S   UNTRACE        	; CONTINUE WITH TRACE


;;; END UP HERE AFTER BREAKPOINTING ONE INSTRUCTION
;;; -- PUT BP BACK IN AND CONTINUE TO RUN

TRACE39  CLR.L   TRACECNT
         BSR.S   SWAPIN         	; PUT BP INTO USER'S MEMORY
         BRA.S   UNSTACK        	; CONTINUE TO RUN


UNTRACE  ORI.W   #$8000,REGSR+2 	; SET UP TRACE BIT!
         ADDR2MEM TRACE,AV9     	; TAKE TRACE VECTOR

UNSTACK  MOVE.L  REGUS,A1
         MOVE.L  A1,USP         	; US = TARGET'S USER STACK
         MOVE.L  REGPC,A2       	; A2 = TARGET'S PC


         DS      0              	; INSURE MEMORY AT LOCATION OF PC
         MOVE.W  (A2),D0        	; * ADDR TRAP ERROR * IF NO MEMORY

         MOVE.L  REGA7,A1       	; A1 = TARGET SYSTEM STACK (SS)

         DS      0              	; INSURE MEMORY AT TARGET'S STACK
         MOVE.L  A2,-(A1)       	; MOVE PC ONTO TARGET'S STACK

         MOVE.W  REGSR+2,D0
         MOVE.W  D0,-(A1)       	; SR ONTO TARGET'S STACK

         MOVE.L  A1,TEMP        	; TEMP = TARGETS SS

         LEA     REGS,A7        	; A7 = POINTER TO PSUEDO REGISTERS
         MOVEM.L (A7)+,D0-D7/A0-A6  	; ARM MOST OF TARGET REGISTERS
         MOVE.L  TEMP,A7        	; SS = TARGET'S

         RTE                    	; GO BACK TO THE USER


SWAPIN   BSR.S   SWAPOUT        	; MAKE SURE THEY ARE ALL OUT

         MOVE.L  AV4,SAVEAV4    	; SAVE VECTOR (WHOM EVER'S IT WAS)
         LEA     CHKBP(PC),A6
         MOVE.L  A6,AV4         	; REPLACE IT WITH THE "CHKBP" RTN
         LEA     SWAPIN1(PC),A6 	; A6 = ROUTINE ADDRESS
         BRA.S   SWAP

SWAPOUT  TST.W   BPSTATUS       	; SEE IF OUT ALREADY
         BEQ.S   SWAPEND         	; YES...DONE
         MOVE.L  SAVEAV4,AV4     	; NO....REPLACE THE VECTOR

         LEA     SWAPOUT1(PC),A6 	; A6 = ROUTINE ADDRESS
SWAP     LEA     BPADD,A0       	; A0 = ADDRESS OF TABLE
         LEA     BPCNT,A2       	; A2 = ADDRESS OF COUNTS
         MOVEQ   #9,D7          	; DO 9 BP
         LEA     BPDATA,A3      	; CONTENT TABLE

SWAP1    MOVE.L  (A0),A4        	; GET POSSIBLE ADDDRESS
         TST.L   (A0)           	; IS POSSIBLE ADDRESS ZERO
         BEQ.S   SWAP99         	; ZERO MEANS NO BP DEFINED
         JMP     (A6)           	; GO TO RIGHT ROUTINE

SWAPIN1
         MOVE.W  (A4),D0        	; USER'S PROGRAM GOES INTO TABLE

         MOVE.W  D0,(A3)
         MOVE.W  #BKPOINT,(A4)  	; PUT BREAKPOINT IN

         MOVE.W  #1,BPSTATUS    	; FLAG AS BP IN
         BRA.S   SWAP99

SWAPOUT1 MOVE.W  (A3),D0        	; GET CONTENTS FROM TABLE
         MOVE.W  D0,(A4)        	; PUT CONTENTS BACK INTO PROGRAM

         CLR.W   BPSTATUS       	; FLAG AS BREAKPOINTS OUT
SWAP99   ADDQ.L  #4,A0          	; BUMP ADDRESS TABLE POINTER
         ADDQ.L  #2,A3          	; BUMP CONTENT TABLE POINTER
         SUBQ.L  #1,D7
         BNE     SWAP1
SWAPEND  RTS

;;;  ILLEGAL INSTRUCTION ENTRY POINT
;;;   BREAKPOINT TEST
;;;
CHKBP    MOVE.W  #$2700,SR      	; MASK OF INT.
         SAVEREGS
         MOVE.L  REGPC,D0       	; GET PROGRAM COUNTER TO COMPARE
         MOVE.L  D0,A5          	; A5 = TARGET PC
         MOVE.W  (A5),D1        	; SEE WHAT OP CODE WAS XEQ

         BSR     SWAPOUT        	; TAKE BREAKPOINTS OUT

         CMPI.W  #BKPOINT,D1    	; USED FOR BP
         BNE.S   CHKBP11        	; NOT AT BREAKPOINT

         LEA     BPADD,A0       	; A0 = ADDRESS OF BP ADDRESSES
         LEA     BPCNT,A2       	; A2 = ADDRESS OF BP COUNTS
         MOVEQ   #9,D7          	; D7 = LOOP COUNT

CHKBP1   CMP.L   (A0),A5        	; SEE IF WE ARE THERE
         BEQ.S   CHKBP2         	; AT BREAKPOINT; AT AN ADDRESS

         ADDQ.L  #4,A0          	; BUMP BOTH POINTERS
         ADDQ.L  #4,A2
         SUBQ.L  #1,D7
         BNE     CHKBP1

;;; IS NOT A BREAKPOINT; ASSUME ILLEGAL INSTRUCTION
CHKBP11  LEA     MSG009(PC),A5  	; 'ILLEGAL INSTRUCTION'
         CLR.W   TRACEON        	; RESET TRACE MODE
         BRA.S   CHKBP4

;;; AT BREAKPOINT...CHECK COUNT
CHKBP2   MOVE.L  (A2),D0        	; GET COUNT
         BEQ.S   CHKBP3         	; COUNT ZERO
         SUBQ.L  #1,D0          	; DECREMENT
         MOVE.L  D0,(A2)        	; PUT COUNT BACK
         BNE     GOCMD1         	; COUNT NOT ZERO; KEEP GOING

CHKBP3   LEA     MSG014(PC),A5  	; "AT BREAKPOINT"

CHKBP4   BSR     FIXDCRLF
         BSR     OUT1CR
         BSR     TDISPLY        	; PRINT TRACE DISPLAY
         BRA     MACSBUG

MSG009   DC.B    'ILLEGAL INSTRUCTION',EOT




MSG014   DC.B    'AT BREAKPOINT',EOT



MSG020   DC.B    '.PC within "DEBUGGER"',BELL,EOT


         DC.B    0              PAD BYTE

